"""
The prompts here are copied from https://github.com/openai/CLIP/blob/main/data/prompts.md
"""

birdsnap_classes = [
    'Acadian Flycatcher',
    'Acorn Woodpecker',
    'Alder Flycatcher',
    'Allens Hummingbird',
    'Altamira Oriole',
    'American Avocet',
    'American Bittern',
    'American Black Duck',
    'American Coot',
    'American Crow',
    'American Dipper',
    'American Golden Plover',
    'American Goldfinch',
    'American Kestrel',
    'American Oystercatcher',
    'American Pipit',
    'American Redstart',
    'American Robin',
    'American Three toed Woodpecker',
    'American Tree Sparrow',
    'American White Pelican',
    'American Wigeon',
    'American Woodcock',
    'Anhinga',
    'Annas Hummingbird',
    'Arctic Tern',
    'Ash throated Flycatcher',
    'Audubons Oriole',
    'Bairds Sandpiper',
    'Bald Eagle',
    'Baltimore Oriole',
    'Band tailed Pigeon',
    'Barn Swallow',
    'Barred Owl',
    'Barrows Goldeneye',
    'Bay breasted Warbler',
    'Bells Vireo',
    'Belted Kingfisher',
    'Bewicks Wren',
    'Black Guillemot',
    'Black Oystercatcher',
    'Black Phoebe',
    'Black Rosy Finch',
    'Black Scoter',
    'Black Skimmer',
    'Black Tern',
    'Black Turnstone',
    'Black Vulture',
    'Black and white Warbler',
    'Black backed Woodpecker',
    'Black bellied Plover',
    'Black billed Cuckoo',
    'Black billed Magpie',
    'Black capped Chickadee',
    'Black chinned Hummingbird',
    'Black chinned Sparrow',
    'Black crested Titmouse',
    'Black crowned Night Heron',
    'Black headed Grosbeak',
    'Black legged Kittiwake',
    'Black necked Stilt',
    'Black throated Blue Warbler',
    'Black throated Gray Warbler',
    'Black throated Green Warbler',
    'Black throated Sparrow',
    'Blackburnian Warbler',
    'Blackpoll Warbler',
    'Blue Grosbeak',
    'Blue Jay',
    'Blue gray Gnatcatcher',
    'Blue headed Vireo',
    'Blue winged Teal',
    'Blue winged Warbler',
    'Boat tailed Grackle',
    'Bobolink',
    'Bohemian Waxwing',
    'Bonapartes Gull',
    'Boreal Chickadee',
    'Brandts Cormorant',
    'Brant',
    'Brewers Blackbird',
    'Brewers Sparrow',
    'Bridled Titmouse',
    'Broad billed Hummingbird',
    'Broad tailed Hummingbird',
    'Broad winged Hawk',
    'Bronzed Cowbird',
    'Brown Creeper',
    'Brown Pelican',
    'Brown Thrasher',
    'Brown capped Rosy Finch',
    'Brown crested Flycatcher',
    'Brown headed Cowbird',
    'Brown headed Nuthatch',
    'Bufflehead',
    'Bullocks Oriole',
    'Burrowing Owl',
    'Bushtit',
    'Cackling Goose',
    'Cactus Wren',
    'California Gull',
    'California Quail',
    'California Thrasher',
    'California Towhee',
    'Calliope Hummingbird',
    'Canada Goose',
    'Canada Warbler',
    'Canvasback',
    'Canyon Towhee',
    'Canyon Wren',
    'Cape May Warbler',
    'Carolina Chickadee',
    'Carolina Wren',
    'Caspian Tern',
    'Cassins Finch',
    'Cassins Kingbird',
    'Cassins Sparrow',
    'Cassins Vireo',
    'Cattle Egret',
    'Cave Swallow',
    'Cedar Waxwing',
    'Cerulean Warbler',
    'Chestnut backed Chickadee',
    'Chestnut collared Longspur',
    'Chestnut sided Warbler',
    'Chihuahuan Raven',
    'Chimney Swift',
    'Chipping Sparrow',
    'Cinnamon Teal',
    'Clapper Rail',
    'Clarks Grebe',
    'Clarks Nutcracker',
    'Clay colored Sparrow',
    'Cliff Swallow',
    'Common Black Hawk',
    'Common Eider',
    'Common Gallinule',
    'Common Goldeneye',
    'Common Grackle',
    'Common Ground Dove',
    'Common Loon',
    'Common Merganser',
    'Common Murre',
    'Common Nighthawk',
    'Common Raven',
    'Common Redpoll',
    'Common Tern',
    'Common Yellowthroat',
    'Connecticut Warbler',
    'Coopers Hawk',
    'Cordilleran Flycatcher',
    'Costas Hummingbird',
    'Couchs Kingbird',
    'Crested Caracara',
    'Curve billed Thrasher',
    'Dark eyed Junco',
    'Dickcissel',
    'Double crested Cormorant',
    'Downy Woodpecker',
    'Dunlin',
    'Dusky Flycatcher',
    'Dusky Grouse',
    'Eared Grebe',
    'Eastern Bluebird',
    'Eastern Kingbird',
    'Eastern Meadowlark',
    'Eastern Phoebe',
    'Eastern Screech Owl',
    'Eastern Towhee',
    'Eastern Wood Pewee',
    'Elegant Trogon',
    'Elf Owl',
    'Eurasian Collared Dove',
    'Eurasian Wigeon',
    'European Starling',
    'Evening Grosbeak',
    'Ferruginous Hawk',
    'Ferruginous Pygmy Owl',
    'Field Sparrow',
    'Fish Crow',
    'Florida Scrub Jay',
    'Forsters Tern',
    'Fox Sparrow',
    'Franklins Gull',
    'Fulvous Whistling Duck',
    'Gadwall',
    'Gambels Quail',
    'Gila Woodpecker',
    'Glaucous Gull',
    'Glaucous winged Gull',
    'Glossy Ibis',
    'Golden Eagle',
    'Golden crowned Kinglet',
    'Golden crowned Sparrow',
    'Golden fronted Woodpecker',
    'Golden winged Warbler',
    'Grasshopper Sparrow',
    'Gray Catbird',
    'Gray Flycatcher',
    'Gray Jay',
    'Gray Kingbird',
    'Gray cheeked Thrush',
    'Gray crowned Rosy Finch',
    'Great Black backed Gull',
    'Great Blue Heron',
    'Great Cormorant',
    'Great Crested Flycatcher',
    'Great Egret',
    'Great Gray Owl',
    'Great Horned Owl',
    'Great Kiskadee',
    'Great tailed Grackle',
    'Greater Prairie Chicken',
    'Greater Roadrunner',
    'Greater Sage Grouse',
    'Greater Scaup',
    'Greater White fronted Goose',
    'Greater Yellowlegs',
    'Green Jay',
    'Green tailed Towhee',
    'Green winged Teal',
    'Groove billed Ani',
    'Gull billed Tern',
    'Hairy Woodpecker',
    'Hammonds Flycatcher',
    'Harlequin Duck',
    'Harriss Hawk',
    'Harriss Sparrow',
    'Heermanns Gull',
    'Henslows Sparrow',
    'Hepatic Tanager',
    'Hermit Thrush',
    'Herring Gull',
    'Hoary Redpoll',
    'Hooded Merganser',
    'Hooded Oriole',
    'Hooded Warbler',
    'Horned Grebe',
    'Horned Lark',
    'House Finch',
    'House Sparrow',
    'House Wren',
    'Huttons Vireo',
    'Iceland Gull',
    'Inca Dove',
    'Indigo Bunting',
    'Killdeer',
    'King Rail',
    'Ladder backed Woodpecker',
    'Lapland Longspur',
    'Lark Bunting',
    'Lark Sparrow',
    'Laughing Gull',
    'Lazuli Bunting',
    'Le Contes Sparrow',
    'Least Bittern',
    'Least Flycatcher',
    'Least Grebe',
    'Least Sandpiper',
    'Least Tern',
    'Lesser Goldfinch',
    'Lesser Nighthawk',
    'Lesser Scaup',
    'Lesser Yellowlegs',
    'Lewiss Woodpecker',
    'Limpkin',
    'Lincolns Sparrow',
    'Little Blue Heron',
    'Loggerhead Shrike',
    'Long billed Curlew',
    'Long billed Dowitcher',
    'Long billed Thrasher',
    'Long eared Owl',
    'Long tailed Duck',
    'Louisiana Waterthrush',
    'Magnificent Frigatebird',
    'Magnolia Warbler',
    'Mallard',
    'Marbled Godwit',
    'Marsh Wren',
    'Merlin',
    'Mew Gull',
    'Mexican Jay',
    'Mississippi Kite',
    'Monk Parakeet',
    'Mottled Duck',
    'Mountain Bluebird',
    'Mountain Chickadee',
    'Mountain Plover',
    'Mourning Dove',
    'Mourning Warbler',
    'Muscovy Duck',
    'Mute Swan',
    'Nashville Warbler',
    'Nelsons Sparrow',
    'Neotropic Cormorant',
    'Northern Bobwhite',
    'Northern Cardinal',
    'Northern Flicker',
    'Northern Gannet',
    'Northern Goshawk',
    'Northern Harrier',
    'Northern Hawk Owl',
    'Northern Mockingbird',
    'Northern Parula',
    'Northern Pintail',
    'Northern Rough winged Swallow',
    'Northern Saw whet Owl',
    'Northern Shrike',
    'Northern Waterthrush',
    'Nuttalls Woodpecker',
    'Oak Titmouse',
    'Olive Sparrow',
    'Olive sided Flycatcher',
    'Orange crowned Warbler',
    'Orchard Oriole',
    'Osprey',
    'Ovenbird',
    'Pacific Golden Plover',
    'Pacific Loon',
    'Pacific Wren',
    'Pacific slope Flycatcher',
    'Painted Bunting',
    'Painted Redstart',
    'Palm Warbler',
    'Pectoral Sandpiper',
    'Peregrine Falcon',
    'Phainopepla',
    'Philadelphia Vireo',
    'Pied billed Grebe',
    'Pigeon Guillemot',
    'Pileated Woodpecker',
    'Pine Grosbeak',
    'Pine Siskin',
    'Pine Warbler',
    'Piping Plover',
    'Plumbeous Vireo',
    'Prairie Falcon',
    'Prairie Warbler',
    'Prothonotary Warbler',
    'Purple Finch',
    'Purple Gallinule',
    'Purple Martin',
    'Purple Sandpiper',
    'Pygmy Nuthatch',
    'Pyrrhuloxia',
    'Red Crossbill',
    'Red Knot',
    'Red Phalarope',
    'Red bellied Woodpecker',
    'Red breasted Merganser',
    'Red breasted Nuthatch',
    'Red breasted Sapsucker',
    'Red cockaded Woodpecker',
    'Red eyed Vireo',
    'Red headed Woodpecker',
    'Red naped Sapsucker',
    'Red necked Grebe',
    'Red necked Phalarope',
    'Red shouldered Hawk',
    'Red tailed Hawk',
    'Red throated Loon',
    'Red winged Blackbird',
    'Reddish Egret',
    'Redhead',
    'Ring billed Gull',
    'Ring necked Duck',
    'Ring necked Pheasant',
    'Rock Pigeon',
    'Rock Ptarmigan',
    'Rock Sandpiper',
    'Rock Wren',
    'Rose breasted Grosbeak',
    'Roseate Tern',
    'Rosss Goose',
    'Rough legged Hawk',
    'Royal Tern',
    'Ruby crowned Kinglet',
    'Ruby throated Hummingbird',
    'Ruddy Duck',
    'Ruddy Turnstone',
    'Ruffed Grouse',
    'Rufous Hummingbird',
    'Rufous crowned Sparrow',
    'Rusty Blackbird',
    'Sage Thrasher',
    'Saltmarsh Sparrow',
    'Sanderling',
    'Sandhill Crane',
    'Sandwich Tern',
    'Says Phoebe',
    'Scaled Quail',
    'Scarlet Tanager',
    'Scissor tailed Flycatcher',
    'Scotts Oriole',
    'Seaside Sparrow',
    'Sedge Wren',
    'Semipalmated Plover',
    'Semipalmated Sandpiper',
    'Sharp shinned Hawk',
    'Sharp tailed Grouse',
    'Short billed Dowitcher',
    'Short eared Owl',
    'Snail Kite',
    'Snow Bunting',
    'Snow Goose',
    'Snowy Egret',
    'Snowy Owl',
    'Snowy Plover',
    'Solitary Sandpiper',
    'Song Sparrow',
    'Sooty Grouse',
    'Sora',
    'Spotted Owl',
    'Spotted Sandpiper',
    'Spotted Towhee',
    'Spruce Grouse',
    'Stellers Jay',
    'Stilt Sandpiper',
    'Summer Tanager',
    'Surf Scoter',
    'Surfbird',
    'Swainsons Hawk',
    'Swainsons Thrush',
    'Swallow tailed Kite',
    'Swamp Sparrow',
    'Tennessee Warbler',
    'Thayers Gull',
    'Townsends Solitaire',
    'Townsends Warbler',
    'Tree Swallow',
    'Tricolored Heron',
    'Tropical Kingbird',
    'Trumpeter Swan',
    'Tufted Titmouse',
    'Tundra Swan',
    'Turkey Vulture',
    'Upland Sandpiper',
    'Varied Thrush',
    'Veery',
    'Verdin',
    'Vermilion Flycatcher',
    'Vesper Sparrow',
    'Violet green Swallow',
    'Virginia Rail',
    'Wandering Tattler',
    'Warbling Vireo',
    'Western Bluebird',
    'Western Grebe',
    'Western Gull',
    'Western Kingbird',
    'Western Meadowlark',
    'Western Sandpiper',
    'Western Screech Owl',
    'Western Scrub Jay',
    'Western Tanager',
    'Western Wood Pewee',
    'Whimbrel',
    'White Ibis',
    'White breasted Nuthatch',
    'White crowned Sparrow',
    'White eyed Vireo',
    'White faced Ibis',
    'White headed Woodpecker',
    'White rumped Sandpiper',
    'White tailed Hawk',
    'White tailed Kite',
    'White tailed Ptarmigan',
    'White throated Sparrow',
    'White throated Swift',
    'White winged Crossbill',
    'White winged Dove',
    'White winged Scoter',
    'Wild Turkey',
    'Willet',
    'Williamsons Sapsucker',
    'Willow Flycatcher',
    'Willow Ptarmigan',
    'Wilsons Phalarope',
    'Wilsons Plover',
    'Wilsons Snipe',
    'Wilsons Warbler',
    'Winter Wren',
    'Wood Stork',
    'Wood Thrush',
    'Worm eating Warbler',
    'Wrentit',
    'Yellow Warbler',
    'Yellow bellied Flycatcher',
    'Yellow bellied Sapsucker',
    'Yellow billed Cuckoo',
    'Yellow billed Magpie',
    'Yellow breasted Chat',
    'Yellow crowned Night Heron',
    'Yellow eyed Junco',
    'Yellow headed Blackbird',
    'Yellow rumped Warbler',
    'Yellow throated Vireo',
    'Yellow throated Warbler',
    'Zone tailed Hawk',
]

birdsnap_templates = [
    'a photo of a {}, a type of bird.',
]


cifar10_classes = [
    'airplane',
    'automobile',
    'bird',
    'cat',
    'deer',
    'dog',
    'frog',
    'horse',
    'ship',
    'truck',
]

cifar10_templates = [
    'a photo of a {}.',
    'a blurry photo of a {}.',
    'a black and white photo of a {}.',
    'a low contrast photo of a {}.',
    'a high contrast photo of a {}.',
    'a bad photo of a {}.',
    'a good photo of a {}.',
    'a photo of a small {}.',
    'a photo of a big {}.',
    'a photo of the {}.',
    'a blurry photo of the {}.',
    'a black and white photo of the {}.',
    'a low contrast photo of the {}.',
    'a high contrast photo of the {}.',
    'a bad photo of the {}.',
    'a good photo of the {}.',
    'a photo of the small {}.',
    'a photo of the big {}.',
]

cifar100_classes = [
    'chimpanzee',
    'trout',
    'skunk',
    'spider',
    'chair',
    'tank',
    'keyboard',
    'man',
    'whale',
    'lobster',
    'house',
    'beetle',
    'bear',
    'shrew',
    'bottle',
    'cup',
    'bus',
    'orange',
    'sea',
    'oak tree',
    'bed',
    'tulip',
    'rabbit',
    'skyscraper',
    'apple',
    'maple tree',
    'pine tree',
    'snail',
    'pear',
    'bridge',
    'train',
    'mountain',
    'caterpillar',
    'crocodile',
    'snake',
    'kangaroo',
    'dolphin',
    'cattle',
    'raccoon',
    'mushroom',
    'hamster',
    'bowl',
    'lamp',
    'rocket',
    'pickup truck',
    'wolf',
    'worm',
    'otter',
    'sunflower',
    'leopard',
    'ray',
    'lawn mower',
    'motorcycle',
    'boy',
    'fox',
    'palm tree',
    'cloud',
    'dinosaur',
    'turtle',
    'forest',
    'couch',
    'poppy',
    'rose',
    'bee',
    'girl',
    'clock',
    'can',
    'table',
    'road',
    'orchid',
    'streetcar',
    'squirrel',
    'crab',
    'butterfly',
    'tractor',
    'beaver',
    'willow tree',
    'camel',
    'plain',
    'mouse',
    'elephant',
    'flatfish',
    'sweet pepper',
    'plate',
    'television',
    'aquarium fish',
    'wardrobe',
    'seal',
    'lizard',
    'cockroach',
    'porcupine',
    'woman',
    'possum',
    'baby',
    'tiger',
    'telephone',
    'shark',
    'lion',
    'castle',
    'bicycle',
    ]

cifar100_templates = [
    'a photo of a {}.',
    'a blurry photo of a {}.',
    'a black and white photo of a {}.',
    'a low contrast photo of a {}.',
    'a high contrast photo of a {}.',
    'a bad photo of a {}.',
    'a good photo of a {}.',
    'a photo of a small {}.',
    'a photo of a big {}.',
    'a photo of the {}.',
    'a blurry photo of the {}.',
    'a black and white photo of the {}.',
    'a low contrast photo of the {}.',
    'a high contrast photo of the {}.',
    'a bad photo of the {}.',
    'a good photo of the {}.',
    'a photo of the small {}.',
    'a photo of the big {}.',
]

clevrcounts_classes = [
    '10',
    '3',
    '4',
    '5',
    '6',
    '7',
    '8',
    '9',
]

clevrcounts_templates = [
    'a photo of {} objects.',
]

caltech101_classes = [
    'accordion',
    'airplane',
    'anchor',
    'ant',
    'background',
    'barrel',
    'bass',
    'beaver',
    'binocular',
    'bonsai',
    'brain',
    'brontosaurus',
    'buddha',
    'butterfly',
    'camera',
    'cannon',
    'side of a car',
    'ceiling fan',
    'cellphone',
    'chair',
    'chandelier',
    'body of a cougar cat',
    'face of a cougar cat',
    'crab',
    'crayfish',
    'crocodile',
    'head of a  crocodile',
    'cup',
    'dalmatian',
    'dollar bill',
    'dolphin',
    'dragonfly',
    'electric guitar',
    'elephant',
    'emu',
    'euphonium',
    'ewer',
    'centered face',
    'off-center face',
    'ferry',
    'flamingo',
    'head of a flamingo',
    'garfield',
    'gerenuk',
    'gramophone',
    'grand piano',
    'hawksbill',
    'headphone',
    'hedgehog',
    'helicopter',
    'ibis',
    'inline skate',
    'joshua tree',
    'kangaroo',
    'ketch',
    'lamp',
    'laptop',
    'leopard',
    'llama',
    'lobster',
    'lotus',
    'mandolin',
    'mayfly',
    'menorah',
    'metronome',
    'minaret',
    'motorbike',
    'nautilus',
    'octopus',
    'okapi',
    'pagoda',
    'panda',
    'pigeon',
    'pizza',
    'platypus',
    'pyramid',
    'revolver',
    'rhino',
    'rooster',
    'saxophone',
    'schooner',
    'scissors',
    'scorpion',
    'sea horse',
    'snoopy (cartoon beagle)',
    'soccer ball',
    'stapler',
    'starfish',
    'stegosaurus',
    'stop sign',
    'strawberry',
    'sunflower',
    'tick',
    'trilobite',
    'umbrella',
    'watch',
    'water lilly',
    'wheelchair',
    'wild cat',
    'windsor chair',
    'wrench',
    'yin and yang symbol',
]

caltech101_templates = [
    'a photo of a {}.',
    'a painting of a {}.',
    'a plastic {}.',
    'a sculpture of a {}.',
    'a sketch of a {}.',
    'a tattoo of a {}.',
    'a toy {}.',
    'a rendition of a {}.',
    'a embroidered {}.',
    'a cartoon {}.',
    'a {} in a video game.',
    'a plushie {}.',
    'a origami {}.',
    'art of a {}.',
    'graffiti of a {}.',
    'a drawing of a {}.',
    'a doodle of a {}.',
    'a photo of the {}.',
    'a painting of the {}.',
    'the plastic {}.',
    'a sculpture of the {}.',
    'a sketch of the {}.',
    'a tattoo of the {}.',
    'the toy {}.',
    'a rendition of the {}.',
    'the embroidered {}.',
    'the cartoon {}.',
    'the {} in a video game.',
    'the plushie {}.',
    'the origami {}.',
    'art of the {}.',
    'graffiti of the {}.',
    'a drawing of the {}.',
    'a doodle of the {}.',
]


country211_classes = [
    'Andorra',
    'United Arab Emirates',
    'Afghanistan',
    'Antigua and Barbuda',
    'Anguilla',
    'Albania',
    'Armenia',
    'Angola',
    'Antarctica',
    'Argentina',
    'Austria',
    'Australia',
    'Aruba',
    'Aland Islands',
    'Azerbaijan',
    'Bosnia and Herzegovina',
    'Barbados',
    'Bangladesh',
    'Belgium',
    'Burkina Faso',
    'Bulgaria',
    'Bahrain',
    'Benin',
    'Bermuda',
    'Brunei Darussalam',
    'Bolivia',
    'Bonaire, Saint Eustatius and Saba',
    'Brazil',
    'Bahamas',
    'Bhutan',
    'Botswana',
    'Belarus',
    'Belize',
    'Canada',
    'DR Congo',
    'Central African Republic',
    'Switzerland',
    "Cote d'Ivoire",
    'Cook Islands',
    'Chile',
    'Cameroon',
    'China',
    'Colombia',
    'Costa Rica',
    'Cuba',
    'Cabo Verde',
    'Curacao',
    'Cyprus',
    'Czech Republic',
    'Germany',
    'Denmark',
    'Dominica',
    'Dominican Republic',
    'Algeria',
    'Ecuador',
    'Estonia',
    'Egypt',
    'Spain',
    'Ethiopia',
    'Finland',
    'Fiji',
    'Falkland Islands',
    'Faeroe Islands',
    'France',
    'Gabon',
    'United Kingdom',
    'Grenada',
    'Georgia',
    'French Guiana',
    'Guernsey',
    'Ghana',
    'Gibraltar',
    'Greenland',
    'Gambia',
    'Guadeloupe',
    'Greece',
    'South Georgia and South Sandwich Is.',
    'Guatemala',
    'Guam',
    'Guyana',
    'Hong Kong',
    'Honduras',
    'Croatia',
    'Haiti',
    'Hungary',
    'Indonesia',
    'Ireland',
    'Israel',
    'Isle of Man',
    'India',
    'Iraq',
    'Iran',
    'Iceland',
    'Italy',
    'Jersey',
    'Jamaica',
    'Jordan',
    'Japan',
    'Kenya',
    'Kyrgyz Republic',
    'Cambodia',
    'St. Kitts and Nevis',
    'North Korea',
    'South Korea',
    'Kuwait',
    'Cayman Islands',
    'Kazakhstan',
    'Laos',
    'Lebanon',
    'St. Lucia',
    'Liechtenstein',
    'Sri Lanka',
    'Liberia',
    'Lithuania',
    'Luxembourg',
    'Latvia',
    'Libya',
    'Morocco',
    'Monaco',
    'Moldova',
    'Montenegro',
    'Saint-Martin',
    'Madagascar',
    'Macedonia',
    'Mali',
    'Myanmar',
    'Mongolia',
    'Macau',
    'Martinique',
    'Mauritania',
    'Malta',
    'Mauritius',
    'Maldives',
    'Malawi',
    'Mexico',
    'Malaysia',
    'Mozambique',
    'Namibia',
    'New Caledonia',
    'Nigeria',
    'Nicaragua',
    'Netherlands',
    'Norway',
    'Nepal',
    'New Zealand',
    'Oman',
    'Panama',
    'Peru',
    'French Polynesia',
    'Papua New Guinea',
    'Philippines',
    'Pakistan',
    'Poland',
    'Puerto Rico',
    'Palestine',
    'Portugal',
    'Palau',
    'Paraguay',
    'Qatar',
    'Reunion',
    'Romania',
    'Serbia',
    'Russia',
    'Rwanda',
    'Saudi Arabia',
    'Solomon Islands',
    'Seychelles',
    'Sudan',
    'Sweden',
    'Singapore',
    'St. Helena',
    'Slovenia',
    'Svalbard and Jan Mayen Islands',
    'Slovakia',
    'Sierra Leone',
    'San Marino',
    'Senegal',
    'Somalia',
    'South Sudan',
    'El Salvador',
    'Sint Maarten',
    'Syria',
    'Eswatini',
    'Togo',
    'Thailand',
    'Tajikistan',
    'Timor-Leste',
    'Turkmenistan',
    'Tunisia',
    'Tonga',
    'Turkey',
    'Trinidad and Tobago',
    'Taiwan',
    'Tanzania',
    'Ukraine',
    'Uganda',
    'United States',
    'Uruguay',
    'Uzbekistan',
    'Vatican',
    'Venezuela',
    'British Virgin Islands',
    'United States Virgin Islands',
    'Vietnam',
    'Vanuatu',
    'Samoa',
    'Kosovo',
    'Yemen',
    'South Africa',
    'Zambia',
    'Zimbabwe',
]

country211_templates = [
    'a photo i took in {}.',
    'a photo i took while visiting {}.',
    'a photo from my home country of {}.',
    'a photo from my visit to {}.',
    'a photo showing the country of {}.',
]


describabletextures_classes = [
    'banded',
    'blotchy',
    'braided',
    'bubbly',
    'bumpy',
    'chequered',
    'cobwebbed',
    'cracked',
    'crosshatched',
    'crystalline',
    'dotted',
    'fibrous',
    'flecked',
    'freckled',
    'frilly',
    'gauzy',
    'grid',
    'grooved',
    'honeycombed',
    'interlaced',
    'knitted',
    'lacelike',
    'lined',
    'marbled',
    'matted',
    'meshed',
    'paisley',
    'perforated',
    'pitted',
    'pleated',
    'polka-dotted',
    'porous',
    'potholed',
    'scaly',
    'smeared',
    'spiralled',
    'sprinkled',
    'stained',
    'stratified',
    'striped',
    'studded',
    'swirly',
    'veined',
    'waffled',
    'woven',
    'wrinkled',
    'zigzagged',
]

describabletextures_templates = [
    'a photo of a {} texture.',
    'a photo of a {} pattern.',
    'a photo of a {} thing.',
    'a photo of a {} object.',
    'a photo of the {} texture.',
    'a photo of the {} pattern.',
    'a photo of the {} thing.',
    'a photo of the {} object.',
]

eurosat_classes = [
    'annual crop land',
    'forest',
    'brushland or shrubland',
    'highway or road',
    'industrial buildings or commercial buildings',
    'pasture land',
    'permanent crop land',
    'residential buildings or homes or apartments',
    'river',
    'lake or sea',
]

eurosat_templates = [
    'a centered satellite photo of {}.',
    'a centered satellite photo of a {}.',
    'a centered satellite photo of the {}.',
]

fgvcaircraft_classes = [
    '707-320',
    '727-200',
    '737-200',
    '737-300',
    '737-400',
    '737-500',
    '737-600',
    '737-700',
    '737-800',
    '737-900',
    '747-100',
    '747-200',
    '747-300',
    '747-400',
    '757-200',
    '757-300',
    '767-200',
    '767-300',
    '767-400',
    '777-200',
    '777-300',
    'A300B4',
    'A310',
    'A318',
    'A319',
    'A320',
    'A321',
    'A330-200',
    'A330-300',
    'A340-200',
    'A340-300',
    'A340-500',
    'A340-600',
    'A380',
    'An-12',
    'ATR-42',
    'ATR-72',
    'BAE 146-200',
    'BAE 146-300',
    'BAE-125',
    'Beechcraft 1900',
    'Boeing 717',
    'C-130',
    'C-47',
    'Cessna 172',
    'Cessna 208',
    'Cessna 525',
    'Cessna 560',
    'Challenger 600',
    'CRJ-200',
    'CRJ-700',
    'CRJ-900',
    'DC-10',
    'DC-3',
    'DC-6',
    'DC-8',
    'DC-9-30',
    'DH-82',
    'DHC-1',
    'DHC-6',
    'DHC-8-100',
    'DHC-8-300',
    'Dornier 328',
    'DR-400',
    'E-170',
    'E-190',
    'E-195',
    'EMB-120',
    'Embraer Legacy 600',
    'ERJ 135',
    'ERJ 145',
    'Eurofighter Typhoon',
    'F-16A-B',
    'F-A-18',
    'Falcon 2000',
    'Falcon 900',
    'Fokker 100',
    'Fokker 50',
    'Fokker 70',
    'Global Express',
    'Gulfstream IV',
    'Gulfstream V',
    'Hawk T1',
    'Il-76',
    'L-1011',
    'MD-11',
    'MD-80',
    'MD-87',
    'MD-90',
    'Metroliner',
    'Model B200',
    'PA-28',
    'Saab 2000',
    'Saab 340',
    'Spitfire',
    'SR-20',
    'Tornado',
    'Tu-134',
    'Tu-154',
    'Yak-42',
]

fgvcaircraft_templates = [
    'a photo of a {}, a type of aircraft.',
    'a photo of the {}, a type of aircraft.',
]

facialemotionrecognition2013_classes = [
    ['angry'],
    ['disgusted'],
    ['fearful'],
    ['happy', 'smiling'],
    ['neutral', 'bored'],
    ['sad', 'depressed'],
    ['surprised', 'shocked', 'spooked'],
]

facialemotionrecognition2013_templates = [
    'a photo of a {} looking face.',
    'a photo of a face showing the emotion: {}.',
    'a photo of a face looking {}.',
    'a face that looks {}.',
    'they look {}.',
    'look at how {} they are.',
]

flowers102_classes = [
    'pink primrose',
    'hard-leaved pocket orchid',
    'canterbury bells',
    'sweet pea',
    'english marigold',
    'tiger lily',
    'moon orchid',
    'bird of paradise',
    'monkshood',
    'globe thistle',
    'snapdragon',
    "colt's foot",
    'king protea',
    'spear thistle',
    'yellow iris',
    'globe flower',
    'purple coneflower',
    'peruvian lily',
    'balloon flower',
    'giant white arum lily',
    'fire lily',
    'pincushion flower',
    'fritillary',
    'red ginger',
    'grape hyacinth',
    'corn poppy',
    'prince of wales feathers',
    'stemless gentian',
    'artichoke',
    'sweet william',
    'carnation',
    'garden phlox',
    'love in the mist',
    'mexican aster',
    'alpine sea holly',
    'ruby-lipped cattleya',
    'cape flower',
    'great masterwort',
    'siam tulip',
    'lenten rose',
    'barbeton daisy',
    'daffodil',
    'sword lily',
    'poinsettia',
    'bolero deep blue',
    'wallflower',
    'marigold',
    'buttercup',
    'oxeye daisy',
    'common dandelion',
    'petunia',
    'wild pansy',
    'primula',
    'sunflower',
    'pelargonium',
    'bishop of llandaff',
    'gaura',
    'geranium',
    'orange dahlia',
    'pink and yellow dahlia',
    'cautleya spicata',
    'japanese anemone',
    'black-eyed susan',
    'silverbush',
    'californian poppy',
    'osteospermum',
    'spring crocus',
    'bearded iris',
    'windflower',
    'tree poppy',
    'gazania',
    'azalea',
    'water lily',
    'rose',
    'thorn apple',
    'morning glory',
    'passion flower',
    'lotus',
    'toad lily',
    'anthurium',
    'frangipani',
    'clematis',
    'hibiscus',
    'columbine',
    'desert-rose',
    'tree mallow',
    'magnolia',
    'cyclamen',
    'watercress',
    'canna lily',
    'hippeastrum',
    'bee balm',
    'air plant',
    'foxglove',
    'bougainvillea',
    'camellia',
    'mallow',
    'mexican petunia',
    'bromelia',
    'blanket flower',
    'trumpet creeper',
    'blackberry lily',
]

flowers102_templates = [
    'a photo of a {}, a type of flower.',
]

food101_classes = [
    'apple pie',
    'baby back ribs',
    'baklava',
    'beef carpaccio',
    'beef tartare',
    'beet salad',
    'beignets',
    'bibimbap',
    'bread pudding',
    'breakfast burrito',
    'bruschetta',
    'caesar salad',
    'cannoli',
    'caprese salad',
    'carrot cake',
    'ceviche',
    'cheesecake',
    'cheese plate',
    'chicken curry',
    'chicken quesadilla',
    'chicken wings',
    'chocolate cake',
    'chocolate mousse',
    'churros',
    'clam chowder',
    'club sandwich',
    'crab cakes',
    'creme brulee',
    'croque madame',
    'cup cakes',
    'deviled eggs',
    'donuts',
    'dumplings',
    'edamame',
    'eggs benedict',
    'escargots',
    'falafel',
    'filet mignon',
    'fish and chips',
    'foie gras',
    'french fries',
    'french onion soup',
    'french toast',
    'fried calamari',
    'fried rice',
    'frozen yogurt',
    'garlic bread',
    'gnocchi',
    'greek salad',
    'grilled cheese sandwich',
    'grilled salmon',
    'guacamole',
    'gyoza',
    'hamburger',
    'hot and sour soup',
    'hot dog',
    'huevos rancheros',
    'hummus',
    'ice cream',
    'lasagna',
    'lobster bisque',
    'lobster roll sandwich',
    'macaroni and cheese',
    'macarons',
    'miso soup',
    'mussels',
    'nachos',
    'omelette',
    'onion rings',
    'oysters',
    'pad thai',
    'paella',
    'pancakes',
    'panna cotta',
    'peking duck',
    'pho',
    'pizza',
    'pork chop',
    'poutine',
    'prime rib',
    'pulled pork sandwich',
    'ramen',
    'ravioli',
    'red velvet cake',
    'risotto',
    'samosa',
    'sashimi',
    'scallops',
    'seaweed salad',
    'shrimp and grits',
    'spaghetti bolognese',
    'spaghetti carbonara',
    'spring rolls',
    'steak',
    'strawberry shortcake',
    'sushi',
    'tacos',
    'takoyaki',
    'tiramisu',
    'tuna tartare',
    'waffles',
]

food101_templates = [
    'a photo of {}, a type of food.',
]


gtsrb_classes = [
    'red and white circle 20 kph speed limit',
    'red and white circle 30 kph speed limit',
    'red and white circle 50 kph speed limit',
    'red and white circle 60 kph speed limit',
    'red and white circle 70 kph speed limit',
    'red and white circle 80 kph speed limit',
    'end / de-restriction of 80 kph speed limit',
    'red and white circle 100 kph speed limit',
    'red and white circle 120 kph speed limit',
    'red and white circle red car and black car no passing',
    'red and white circle red truck and black car no passing',
    'red and white triangle road intersection warning',
    'white and yellow diamond priority road',
    'red and white upside down triangle yield right-of-way',
    'stop',
    'empty red and white circle',
    'red and white circle no truck entry',
    'red circle with white horizonal stripe no entry',
    'red and white triangle with exclamation mark warning',
    'red and white triangle with black left curve approaching warning',
    'red and white triangle with black right curve approaching warning',
    'red and white triangle with black double curve approaching warning',
    'red and white triangle rough / bumpy road warning',
    'red and white triangle car skidding / slipping warning',
    'red and white triangle with merging / narrow lanes warning',
    'red and white triangle with person digging / construction / road work warning',
    'red and white triangle with traffic light approaching warning',
    'red and white triangle with person walking warning',
    'red and white triangle with child and person walking warning',
    'red and white triangle with bicyle warning',
    'red and white triangle with snowflake / ice warning',
    'red and white triangle with deer warning',
    'white circle with gray strike bar no speed limit',
    'blue circle with white right turn arrow mandatory',
    'blue circle with white left turn arrow mandatory',
    'blue circle with white forward arrow mandatory',
    'blue circle with white forward or right turn arrow mandatory',
    'blue circle with white forward or left turn arrow mandatory',
    'blue circle with white keep right arrow mandatory',
    'blue circle with white keep left arrow mandatory',
    'blue circle with white arrows indicating a traffic circle',
    'white circle with gray strike bar indicating no passing for cars has ended',
    'white circle with gray strike bar indicating no passing for trucks has ended',
]

gtsrb_templates = [
    'a zoomed in photo of a "{}" traffic sign.',
    'a centered photo of a "{}" traffic sign.',
    'a close up photo of a "{}" traffic sign.',
]

hatefulmemes_classes = [
    'meme',
    'hatespeech meme',
]

hatefulmemes_templates = [
    'a {}.',
]

kitti_classes = [
    'a photo i took of a car on my left or right side.',
    'a photo i took with a car nearby.',
    'a photo i took with a car in the distance.',
    'a photo i took with no car.',
]

kitti_templates = [
    '{}',
]

kinetics700_classes = [
    'abseiling',
    'acting in play',
    'adjusting glasses',
    'air drumming',
    'alligator wrestling',
    'answering questions',
    'applauding',
    'applying cream',
    'archaeological excavation',
    'archery',
    'arguing',
    'arm wrestling',
    'arranging flowers',
    'arresting',
    'assembling bicycle',
    'assembling computer',
    'attending conference',
    'auctioning',
    'baby waking up',
    'backflip (human)',
    'baking cookies',
    'bandaging',
    'barbequing',
    'bartending',
    'base jumping',
    'bathing dog',
    'battle rope training',
    'beatboxing',
    'bee keeping',
    'being excited',
    'being in zero gravity',
    'belly dancing',
    'bench pressing',
    'bending back',
    'bending metal',
    'biking through snow',
    'blasting sand',
    'blending fruit',
    'blowdrying hair',
    'blowing bubble gum',
    'blowing glass',
    'blowing leaves',
    'blowing nose',
    'blowing out candles',
    'bobsledding',
    'bodysurfing',
    'bookbinding',
    'bottling',
    'bouncing ball (not juggling)',
    'bouncing on bouncy castle',
    'bouncing on trampoline',
    'bowling',
    'braiding hair',
    'breading or breadcrumbing',
    'breakdancing',
    'breaking boards',
    'breaking glass',
    'breathing fire',
    'brush painting',
    'brushing floor',
    'brushing hair',
    'brushing teeth',
    'building cabinet',
    'building lego',
    'building sandcastle',
    'building shed',
    'bulldozing',
    'bungee jumping',
    'burping',
    'busking',
    'calculating',
    'calligraphy',
    'canoeing or kayaking',
    'capoeira',
    'capsizing',
    'card stacking',
    'card throwing',
    'carrying baby',
    'carrying weight',
    'cartwheeling',
    'carving ice',
    'carving marble',
    'carving pumpkin',
    'carving wood with a knife',
    'casting fishing line',
    'catching fish',
    'catching or throwing baseball',
    'catching or throwing frisbee',
    'catching or throwing softball',
    'celebrating',
    'changing gear in car',
    'changing oil',
    'changing wheel (not on bike)',
    'chasing',
    'checking tires',
    'checking watch',
    'cheerleading',
    'chewing gum',
    'chiseling stone',
    'chiseling wood',
    'chopping meat',
    'chopping wood',
    'clam digging',
    'clapping',
    'clay pottery making',
    'clean and jerk',
    'cleaning gutters',
    'cleaning pool',
    'cleaning shoes',
    'cleaning toilet',
    'cleaning windows',
    'climbing a rope',
    'climbing ladder',
    'climbing tree',
    'closing door',
    'coloring in',
    'combing hair',
    'contact juggling',
    'contorting',
    'cooking chicken',
    'cooking egg',
    'cooking on campfire',
    'cooking sausages (not on barbeque)',
    'cooking scallops',
    'cosplaying',
    'coughing',
    'counting money',
    'country line dancing',
    'cracking back',
    'cracking knuckles',
    'cracking neck',
    'crawling baby',
    'crocheting',
    'crossing eyes',
    'crossing river',
    'crying',
    'cumbia',
    'curling (sport)',
    'curling eyelashes',
    'curling hair',
    'cutting apple',
    'cutting cake',
    'cutting nails',
    'cutting orange',
    'cutting pineapple',
    'cutting watermelon',
    'dancing ballet',
    'dancing charleston',
    'dancing gangnam style',
    'dancing macarena',
    'deadlifting',
    'dealing cards',
    'decorating the christmas tree',
    'decoupage',
    'delivering mail',
    'digging',
    'dining',
    'directing traffic',
    'disc golfing',
    'diving cliff',
    'docking boat',
    'dodgeball',
    'doing aerobics',
    'doing jigsaw puzzle',
    'doing laundry',
    'doing nails',
    'doing sudoku',
    'drawing',
    'dribbling basketball',
    'drinking shots',
    'driving car',
    'driving tractor',
    'drooling',
    'drop kicking',
    'drumming fingers',
    'dumpster diving',
    'dunking basketball',
    'dyeing eyebrows',
    'dyeing hair',
    'eating burger',
    'eating cake',
    'eating carrots',
    'eating chips',
    'eating doughnuts',
    'eating hotdog',
    'eating ice cream',
    'eating nachos',
    'eating spaghetti',
    'eating watermelon',
    'egg hunting',
    'embroidering',
    'entering church',
    'exercising arm',
    'exercising with an exercise ball',
    'extinguishing fire',
    'faceplanting',
    'falling off bike',
    'falling off chair',
    'feeding birds',
    'feeding fish',
    'feeding goats',
    'fencing (sport)',
    'fidgeting',
    'filling cake',
    'filling eyebrows',
    'finger snapping',
    'fixing bicycle',
    'fixing hair',
    'flint knapping',
    'flipping bottle',
    'flipping pancake',
    'fly tying',
    'flying kite',
    'folding clothes',
    'folding napkins',
    'folding paper',
    'front raises',
    'frying vegetables',
    'gargling',
    'geocaching',
    'getting a haircut',
    'getting a piercing',
    'getting a tattoo',
    'giving or receiving award',
    'gold panning',
    'golf chipping',
    'golf driving',
    'golf putting',
    'gospel singing in church',
    'grinding meat',
    'grooming cat',
    'grooming dog',
    'grooming horse',
    'gymnastics tumbling',
    'hammer throw',
    'hand washing clothes',
    'head stand',
    'headbanging',
    'headbutting',
    'helmet diving',
    'herding cattle',
    'high fiving',
    'high jump',
    'high kick',
    'historical reenactment',
    'hitting baseball',
    'hockey stop',
    'holding snake',
    'home roasting coffee',
    'hopscotch',
    'hoverboarding',
    'huddling',
    'hugging (not baby)',
    'hugging baby',
    'hula hooping',
    'hurdling',
    'hurling (sport)',
    'ice climbing',
    'ice fishing',
    'ice skating',
    'ice swimming',
    'inflating balloons',
    'installing carpet',
    'ironing',
    'ironing hair',
    'javelin throw',
    'jaywalking',
    'jetskiing',
    'jogging',
    'juggling balls',
    'juggling fire',
    'juggling soccer ball',
    'jumping bicycle',
    'jumping into pool',
    'jumping jacks',
    'jumping sofa',
    'jumpstyle dancing',
    'karaoke',
    'kicking field goal',
    'kicking soccer ball',
    'kissing',
    'kitesurfing',
    'knitting',
    'krumping',
    'land sailing',
    'laughing',
    'lawn mower racing',
    'laying bricks',
    'laying concrete',
    'laying decking',
    'laying stone',
    'laying tiles',
    'leatherworking',
    'letting go of balloon',
    'licking',
    'lifting hat',
    'lighting candle',
    'lighting fire',
    'listening with headphones',
    'lock picking',
    'long jump',
    'longboarding',
    'looking at phone',
    'looking in mirror',
    'luge',
    'lunge',
    'making a cake',
    'making a sandwich',
    'making balloon shapes',
    'making bubbles',
    'making cheese',
    'making horseshoes',
    'making jewelry',
    'making latte art',
    'making paper aeroplanes',
    'making pizza',
    'making slime',
    'making snowman',
    'making sushi',
    'making tea',
    'making the bed',
    'marching',
    'marriage proposal',
    'massaging back',
    'massaging feet',
    'massaging legs',
    'massaging neck',
    "massaging person's head",
    'metal detecting',
    'milking cow',
    'milking goat',
    'mixing colours',
    'moon walking',
    'mopping floor',
    'mosh pit dancing',
    'motorcycling',
    'mountain climber (exercise)',
    'moving baby',
    'moving child',
    'moving furniture',
    'mowing lawn',
    'mushroom foraging',
    'needle felting',
    'news anchoring',
    'opening bottle (not wine)',
    'opening coconuts',
    'opening door',
    'opening present',
    'opening refrigerator',
    'opening wine bottle',
    'packing',
    'paragliding',
    'parasailing',
    'parkour',
    'passing American football (in game)',
    'passing American football (not in game)',
    'passing soccer ball',
    'peeling apples',
    'peeling banana',
    'peeling potatoes',
    'person collecting garbage',
    'petting animal (not cat)',
    'petting cat',
    'petting horse',
    'photobombing',
    'photocopying',
    'picking apples',
    'picking blueberries',
    'pillow fight',
    'pinching',
    'pirouetting',
    'planing wood',
    'planting trees',
    'plastering',
    'playing accordion',
    'playing american football',
    'playing badminton',
    'playing bagpipes',
    'playing basketball',
    'playing bass guitar',
    'playing beer pong',
    'playing billiards',
    'playing blackjack',
    'playing cards',
    'playing cello',
    'playing checkers',
    'playing chess',
    'playing clarinet',
    'playing controller',
    'playing cricket',
    'playing cymbals',
    'playing darts',
    'playing didgeridoo',
    'playing dominoes',
    'playing drums',
    'playing field hockey',
    'playing flute',
    'playing gong',
    'playing guitar',
    'playing hand clapping games',
    'playing harmonica',
    'playing harp',
    'playing ice hockey',
    'playing keyboard',
    'playing kickball',
    'playing laser tag',
    'playing lute',
    'playing mahjong',
    'playing maracas',
    'playing marbles',
    'playing monopoly',
    'playing netball',
    'playing nose flute',
    'playing oboe',
    'playing ocarina',
    'playing organ',
    'playing paintball',
    'playing pan pipes',
    'playing piano',
    'playing piccolo',
    'playing pinball',
    'playing ping pong',
    'playing poker',
    'playing polo',
    'playing recorder',
    'playing road hockey',
    'playing rounders',
    'playing rubiks cube',
    'playing saxophone',
    'playing scrabble',
    'playing shuffleboard',
    'playing slot machine',
    'playing squash or racquetball',
    'playing tennis',
    'playing trombone',
    'playing trumpet',
    'playing ukulele',
    'playing violin',
    'playing volleyball',
    'playing with trains',
    'playing xylophone',
    'poaching eggs',
    'poking bellybutton',
    'pole vault',
    'polishing furniture',
    'polishing metal',
    'popping balloons',
    'pouring beer',
    'pouring milk',
    'pouring wine',
    'preparing salad',
    'presenting weather forecast',
    'pretending to be a statue',
    'pull ups',
    'pulling espresso shot',
    'pulling rope (game)',
    'pumping fist',
    'pumping gas',
    'punching bag',
    'punching person (boxing)',
    'push up',
    'pushing car',
    'pushing cart',
    'pushing wheelbarrow',
    'pushing wheelchair',
    'putting in contact lenses',
    'putting on eyeliner',
    'putting on foundation',
    'putting on lipstick',
    'putting on mascara',
    'putting on sari',
    'putting on shoes',
    'putting wallpaper on wall',
    'raising eyebrows',
    'reading book',
    'reading newspaper',
    'recording music',
    'repairing puncture',
    'riding a bike',
    'riding camel',
    'riding elephant',
    'riding mechanical bull',
    'riding mule',
    'riding or walking with horse',
    'riding scooter',
    'riding snow blower',
    'riding unicycle',
    'ripping paper',
    'roasting marshmallows',
    'roasting pig',
    'robot dancing',
    'rock climbing',
    'rock scissors paper',
    'roller skating',
    'rolling eyes',
    'rolling pastry',
    'rope pushdown',
    'running on treadmill',
    'sailing',
    'salsa dancing',
    'saluting',
    'sanding floor',
    'sanding wood',
    'sausage making',
    'sawing wood',
    'scrambling eggs',
    'scrapbooking',
    'scrubbing face',
    'scuba diving',
    'seasoning food',
    'separating eggs',
    'setting table',
    'sewing',
    'shaking hands',
    'shaking head',
    'shaping bread dough',
    'sharpening knives',
    'sharpening pencil',
    'shaving head',
    'shaving legs',
    'shearing sheep',
    'shining flashlight',
    'shining shoes',
    'shoot dance',
    'shooting basketball',
    'shooting goal (soccer)',
    'shooting off fireworks',
    'shopping',
    'shot put',
    'shouting',
    'shoveling snow',
    'shredding paper',
    'shucking oysters',
    'shuffling cards',
    'shuffling feet',
    'side kick',
    'sieving',
    'sign language interpreting',
    'silent disco',
    'singing',
    'sipping cup',
    'situp',
    'skateboarding',
    'ski ballet',
    'ski jumping',
    'skiing crosscountry',
    'skiing mono',
    'skiing slalom',
    'skipping rope',
    'skipping stone',
    'skydiving',
    'slacklining',
    'slapping',
    'sled dog racing',
    'sleeping',
    'slicing onion',
    'smashing',
    'smelling feet',
    'smoking',
    'smoking hookah',
    'smoking pipe',
    'snatch weight lifting',
    'sneezing',
    'snorkeling',
    'snowboarding',
    'snowkiting',
    'snowmobiling',
    'somersaulting',
    'spelunking',
    'spinning plates',
    'spinning poi',
    'splashing water',
    'spray painting',
    'spraying',
    'springboard diving',
    'square dancing',
    'squat',
    'squeezing orange',
    'stacking cups',
    'stacking dice',
    'standing on hands',
    'staring',
    'steer roping',
    'steering car',
    'sticking tongue out',
    'stomping grapes',
    'stretching arm',
    'yoga',
]

kinetics700_templates = [
    'a photo of {}.',
    'a photo of a person {}.',
    'a photo of a person using {}.',
    'a photo of a person doing {}.',
    'a photo of a person during {}.',
    'a photo of a person performing {}.',
    'a photo of a person practicing {}.',
    'a video of {}.',
    'a video of a person {}.',
    'a video of a person using {}.',
    'a video of a person doing {}.',
    'a video of a person during {}.',
    'a video of a person performing {}.',
    'a video of a person practicing {}.',
    'a example of {}.',
    'a example of a person {}.',
    'a example of a person using {}.',
    'a example of a person doing {}.',
    'a example of a person during {}.',
    'a example of a person performing {}.',
    'a example of a person practicing {}.',
    'a demonstration of {}.',
    'a demonstration of a person {}.',
    'a demonstration of a person using {}.',
    'a demonstration of a person doing {}.',
    'a demonstration of a person during {}.',
    'a demonstration of a person performing {}.',
    'a demonstration of a person practicing {}.',
]

mnist_classes = [
    '0',
    '1',
    '2',
    '3',
    '4',
    '5',
    '6',
    '7',
    '8',
    '9',
]

mnist_templates = [
    'a photo of the number: "{}".',
]

oxfordpets_classes = [
    'Abyssinian',
    'american bulldog',
    'american pit bull terrier',
    'basset hound',
    'beagle',
    'Bengal',
    'Birman',
    'Bombay',
    'boxer',
    'British Shorthair',
    'chihuahua',
    'Egyptian Mau',
    'english cocker spaniel',
    'english setter',
    'german shorthaired',
    'great pyrenees',
    'havanese',
    'japanese chin',
    'keeshond',
    'leonberger',
    'Maine Coon',
    'miniature pinscher',
    'newfoundland',
    'Persian',
    'pomeranian',
    'pug',
    'Ragdoll',
    'Russian Blue',
    'saint bernard',
    'samoyed',
    'scottish terrier',
    'shiba inu',
    'Siamese',
    'Sphynx',
    'staffordshire bull terrier',
    'wheaten terrier',
    'yorkshire terrier',
]

oxfordpets_templates = [
    'a photo of a {}, a type of pet.',
]


pascalvoc2007_classes = [
    'aeroplane',
    'bicycle',
    'bird',
    'boat',
    'bottle',
    'bus',
    'car',
    'cat',
    'chair',
    'cow',
    'diningtable',
    'dog',
    'horse',
    'motorbike',
    'person',
    'pottedplant',
    'sheep',
    'sofa',
    'train',
    'tvmonitor',
]

pascalvoc2007_templates = [
    'a photo of a {}.',
]

patchcamelyon_classes = [
    'lymph node',
    'lymph node containing metastatic tumor tissue',
]

patchcamelyon_templates = [
    'this is a photo of {}',
]

resisc45_classes = [
    'airplane',
    'airport',
    'baseball diamond',
    'basketball court',
    'beach',
    'bridge',
    'chaparral',
    'church',
    'circular farmland',
    'cloud',
    'commercial area',
    'dense residential',
    'desert',
    'forest',
    'freeway',
    'golf course',
    'ground track field',
    'harbor',
    'industrial area',
    'intersection',
    'island',
    'lake',
    'meadow',
    'medium residential',
    'mobile home park',
    'mountain',
    'overpass',
    'palace',
    'parking lot',
    'railway',
    'railway station',
    'rectangular farmland',
    'river',
    'roundabout',
    'runway',
    'sea ice',
    'ship',
    'snowberg',
    'sparse residential',
    'stadium',
    'storage tank',
    'tennis court',
    'terrace',
    'thermal power station',
    'wetland',
]

resisc45_templates = [
    'satellite imagery of {}.',
    'aerial imagery of {}.',
    'satellite photo of {}.',
    'aerial photo of {}.',
    'satellite view of {}.',
    'aerial view of {}.',
    'satellite imagery of a {}.',
    'aerial imagery of a {}.',
    'satellite photo of a {}.',
    'aerial photo of a {}.',
    'satellite view of a {}.',
    'aerial view of a {}.',
    'satellite imagery of the {}.',
    'aerial imagery of the {}.',
    'satellite photo of the {}.',
    'aerial photo of the {}.',
    'satellite view of the {}.',
    'aerial view of the {}.',
]

sst2_classes = [
    'negative',
    'positive',
]

sst2_templates = [
    'a {} review of a movie.',
]

stl10_classes = [
    'airplane',
    'bird',
    'car',
    'cat',
    'deer',
    'dog',
    'horse',
    'monkey',
    'ship',
    'truck',
]

stl10_templates = [
    'a photo of a {}.',
    'a photo of the {}.',
]

sun397_classes = [
    'abbey',
    'airplane cabin',
    'airport terminal',
    'alley',
    'amphitheater',
    'amusement arcade',
    'amusement park',
    'anechoic chamber',
    'apartment building outdoor',
    'apse indoor',
    'aquarium',
    'aqueduct',
    'arch',
    'archive',
    'arrival gate outdoor',
    'art gallery',
    'art school',
    'art studio',
    'assembly line',
    'athletic field outdoor',
    'atrium public',
    'attic',
    'auditorium',
    'auto factory',
    'badlands',
    'badminton court indoor',
    'baggage claim',
    'bakery shop',
    'balcony exterior',
    'balcony interior',
    'ball pit',
    'ballroom',
    'bamboo forest',
    'banquet hall',
    'bar',
    'barn',
    'barndoor',
    'baseball field',
    'basement',
    'basilica',
    'basketball court outdoor',
    'bathroom',
    'batters box',
    'bayou',
    'bazaar indoor',
    'bazaar outdoor',
    'beach',
    'beauty salon',
    'bedroom',
    'berth',
    'biology laboratory',
    'bistro indoor',
    'boardwalk',
    'boat deck',
    'boathouse',
    'bookstore',
    'booth indoor',
    'botanical garden',
    'bow window indoor',
    'bow window outdoor',
    'bowling alley',
    'boxing ring',
    'brewery indoor',
    'bridge',
    'building facade',
    'bullring',
    'burial chamber',
    'bus interior',
    'butchers shop',
    'butte',
    'cabin outdoor',
    'cafeteria',
    'campsite',
    'campus',
    'canal natural',
    'canal urban',
    'candy store',
    'canyon',
    'car interior backseat',
    'car interior frontseat',
    'carrousel',
    'casino indoor',
    'castle',
    'catacomb',
    'cathedral indoor',
    'cathedral outdoor',
    'cavern indoor',
    'cemetery',
    'chalet',
    'cheese factory',
    'chemistry lab',
    'chicken coop indoor',
    'chicken coop outdoor',
    'childs room',
    'church indoor',
    'church outdoor',
    'classroom',
    'clean room',
    'cliff',
    'cloister indoor',
    'closet',
    'clothing store',
    'coast',
    'cockpit',
    'coffee shop',
    'computer room',
    'conference center',
    'conference room',
    'construction site',
    'control room',
    'control tower outdoor',
    'corn field',
    'corral',
    'corridor',
    'cottage garden',
    'courthouse',
    'courtroom',
    'courtyard',
    'covered bridge exterior',
    'creek',
    'crevasse',
    'crosswalk',
    'cubicle office',
    'dam',
    'delicatessen',
    'dentists office',
    'desert sand',
    'desert vegetation',
    'diner indoor',
    'diner outdoor',
    'dinette home',
    'dinette vehicle',
    'dining car',
    'dining room',
    'discotheque',
    'dock',
    'doorway outdoor',
    'dorm room',
    'driveway',
    'driving range outdoor',
    'drugstore',
    'electrical substation',
    'elevator door',
    'elevator interior',
    'elevator shaft',
    'engine room',
    'escalator indoor',
    'excavation',
    'factory indoor',
    'fairway',
    'fastfood restaurant',
    'field cultivated',
    'field wild',
    'fire escape',
    'fire station',
    'firing range indoor',
    'fishpond',
    'florist shop indoor',
    'food court',
    'forest broadleaf',
    'forest needleleaf',
    'forest path',
    'forest road',
    'formal garden',
    'fountain',
    'galley',
    'game room',
    'garage indoor',
    'garbage dump',
    'gas station',
    'gazebo exterior',
    'general store indoor',
    'general store outdoor',
    'gift shop',
    'golf course',
    'greenhouse indoor',
    'greenhouse outdoor',
    'gymnasium indoor',
    'hangar indoor',
    'hangar outdoor',
    'harbor',
    'hayfield',
    'heliport',
    'herb garden',
    'highway',
    'hill',
    'home office',
    'hospital',
    'hospital room',
    'hot spring',
    'hot tub outdoor',
    'hotel outdoor',
    'hotel room',
    'house',
    'hunting lodge outdoor',
    'ice cream parlor',
    'ice floe',
    'ice shelf',
    'ice skating rink indoor',
    'ice skating rink outdoor',
    'iceberg',
    'igloo',
    'industrial area',
    'inn outdoor',
    'islet',
    'jacuzzi indoor',
    'jail cell',
    'jail indoor',
    'jewelry shop',
    'kasbah',
    'kennel indoor',
    'kennel outdoor',
    'kindergarden classroom',
    'kitchen',
    'kitchenette',
    'labyrinth outdoor',
    'lake natural',
    'landfill',
    'landing deck',
    'laundromat',
    'lecture room',
    'library indoor',
    'library outdoor',
    'lido deck outdoor',
    'lift bridge',
    'lighthouse',
    'limousine interior',
    'living room',
    'lobby',
    'lock chamber',
    'locker room',
    'mansion',
    'manufactured home',
    'market indoor',
    'market outdoor',
    'marsh',
    'martial arts gym',
    'mausoleum',
    'medina',
    'moat water',
    'monastery outdoor',
    'mosque indoor',
    'mosque outdoor',
    'motel',
    'mountain',
    'mountain snowy',
    'movie theater indoor',
    'museum indoor',
    'music store',
    'music studio',
    'nuclear power plant outdoor',
    'nursery',
    'oast house',
    'observatory outdoor',
    'ocean',
    'office',
    'office building',
    'oil refinery outdoor',
    'oilrig',
    'operating room',
    'orchard',
    'outhouse outdoor',
    'pagoda',
    'palace',
    'pantry',
    'park',
    'parking garage indoor',
    'parking garage outdoor',
    'parking lot',
    'parlor',
    'pasture',
    'patio',
    'pavilion',
    'pharmacy',
    'phone booth',
    'physics laboratory',
    'picnic area',
    'pilothouse indoor',
    'planetarium outdoor',
    'playground',
    'playroom',
    'plaza',
    'podium indoor',
    'podium outdoor',
    'pond',
    'poolroom establishment',
    'poolroom home',
    'power plant outdoor',
    'promenade deck',
    'pub indoor',
    'pulpit',
    'putting green',
    'racecourse',
    'raceway',
    'raft',
    'railroad track',
    'rainforest',
    'reception',
    'recreation room',
    'residential neighborhood',
    'restaurant',
    'restaurant kitchen',
    'restaurant patio',
    'rice paddy',
    'riding arena',
    'river',
    'rock arch',
    'rope bridge',
    'ruin',
    'runway',
    'sandbar',
    'sandbox',
    'sauna',
    'schoolhouse',
    'sea cliff',
    'server room',
    'shed',
    'shoe shop',
    'shopfront',
    'shopping mall indoor',
    'shower',
    'skatepark',
    'ski lodge',
    'ski resort',
    'ski slope',
    'sky',
    'skyscraper',
    'slum',
    'snowfield',
    'squash court',
    'stable',
    'stadium baseball',
    'stadium football',
    'stage indoor',
    'staircase',
    'street',
    'subway interior',
    'subway station platform',
    'supermarket',
    'sushi bar',
    'swamp',
    'swimming pool indoor',
    'swimming pool outdoor',
    'synagogue indoor',
    'synagogue outdoor',
    'television studio',
    'temple east asia',
    'temple south asia',
    'tennis court indoor',
    'tennis court outdoor',
    'tent outdoor',
    'theater indoor procenium',
    'theater indoor seats',
    'thriftshop',
    'throne room',
    'ticket booth',
    'toll plaza',
    'topiary garden',
    'tower',
    'toyshop',
    'track outdoor',
    'train railway',
    'train station platform',
    'tree farm',
    'tree house',
    'trench',
    'underwater coral reef',
    'utility room',
    'valley',
    'van interior',
    'vegetable garden',
    'veranda',
    'veterinarians office',
    'viaduct',
    'videostore',
    'village',
    'vineyard',
    'volcano',
    'volleyball court indoor',
    'volleyball court outdoor',
    'waiting room',
    'warehouse indoor',
    'water tower',
    'waterfall block',
    'waterfall fan',
    'waterfall plunge',
    'watering hole',
    'wave',
    'wet bar',
    'wheat field',
    'wind farm',
    'windmill',
    'wine cellar barrel storage',
    'wine cellar bottle storage',
    'wrestling ring indoor',
    'yard',
    'youth hostel',
]

sun397_templates = [
    'a photo of a {}.',
    'a photo of the {}.',
]

stanfordcars_classes = [
    'Acura Integra Type R 2001',
    'Acura RL Sedan 2012',
    'Acura TL Sedan 2012',
    'Acura TL Type-S 2008',
    'Acura TSX Sedan 2012',
    'Acura ZDX Hatchback 2012',
    'AM General Hummer SUV 2000',
    'Aston Martin V8 Vantage Convertible 2012',
    'Aston Martin V8 Vantage Coupe 2012',
    'Aston Martin Virage Convertible 2012',
    'Aston Martin Virage Coupe 2012',
    'Audi 100 Sedan 1994',
    'Audi 100 Wagon 1994',
    'Audi A5 Coupe 2012',
    'Audi R8 Coupe 2012',
    'Audi RS 4 Convertible 2008',
    'Audi S4 Sedan 2007',
    'Audi S4 Sedan 2012',
    'Audi S5 Convertible 2012',
    'Audi S5 Coupe 2012',
    'Audi S6 Sedan 2011',
    'Audi TTS Coupe 2012',
    'Audi TT Hatchback 2011',
    'Audi TT RS Coupe 2012',
    'Audi V8 Sedan 1994',
    'Bentley Arnage Sedan 2009',
    'Bentley Continental Flying Spur Sedan 2007',
    'Bentley Continental GT Coupe 2007',
    'Bentley Continental GT Coupe 2012',
    'Bentley Continental Supersports Conv. Convertible 2012',
    'Bentley Mulsanne Sedan 2011',
    'BMW 1 Series Convertible 2012',
    'BMW 1 Series Coupe 2012',
    'BMW 3 Series Sedan 2012',
    'BMW 3 Series Wagon 2012',
    'BMW 6 Series Convertible 2007',
    'BMW ActiveHybrid 5 Sedan 2012',
    'BMW M3 Coupe 2012',
    'BMW M5 Sedan 2010',
    'BMW M6 Convertible 2010',
    'BMW X3 SUV 2012',
    'BMW X5 SUV 2007',
    'BMW X6 SUV 2012',
    'BMW Z4 Convertible 2012',
    'Bugatti Veyron 16.4 Convertible 2009',
    'Bugatti Veyron 16.4 Coupe 2009',
    'Buick Enclave SUV 2012',
    'Buick Rainier SUV 2007',
    'Buick Regal GS 2012',
    'Buick Verano Sedan 2012',
    'Cadillac CTS-V Sedan 2012',
    'Cadillac Escalade EXT Crew Cab 2007',
    'Cadillac SRX SUV 2012',
    'Chevrolet Avalanche Crew Cab 2012',
    'Chevrolet Camaro Convertible 2012',
    'Chevrolet Cobalt SS 2010',
    'Chevrolet Corvette Convertible 2012',
    'Chevrolet Corvette Ron Fellows Edition Z06 2007',
    'Chevrolet Corvette ZR1 2012',
    'Chevrolet Express Cargo Van 2007',
    'Chevrolet Express Van 2007',
    'Chevrolet HHR SS 2010',
    'Chevrolet Impala Sedan 2007',
    'Chevrolet Malibu Hybrid Sedan 2010',
    'Chevrolet Malibu Sedan 2007',
    'Chevrolet Monte Carlo Coupe 2007',
    'Chevrolet Silverado 1500 Classic Extended Cab 2007',
    'Chevrolet Silverado 1500 Extended Cab 2012',
    'Chevrolet Silverado 1500 Hybrid Crew Cab 2012',
    'Chevrolet Silverado 1500 Regular Cab 2012',
    'Chevrolet Silverado 2500HD Regular Cab 2012',
    'Chevrolet Sonic Sedan 2012',
    'Chevrolet Tahoe Hybrid SUV 2012',
    'Chevrolet TrailBlazer SS 2009',
    'Chevrolet Traverse SUV 2012',
    'Chrysler 300 SRT-8 2010',
    'Chrysler Aspen SUV 2009',
    'Chrysler Crossfire Convertible 2008',
    'Chrysler PT Cruiser Convertible 2008',
    'Chrysler Sebring Convertible 2010',
    'Chrysler Town and Country Minivan 2012',
    'Daewoo Nubira Wagon 2002',
    'Dodge Caliber Wagon 2007',
    'Dodge Caliber Wagon 2012',
    'Dodge Caravan Minivan 1997',
    'Dodge Challenger SRT8 2011',
    'Dodge Charger Sedan 2012',
    'Dodge Charger SRT-8 2009',
    'Dodge Dakota Club Cab 2007',
    'Dodge Dakota Crew Cab 2010',
    'Dodge Durango SUV 2007',
    'Dodge Durango SUV 2012',
    'Dodge Journey SUV 2012',
    'Dodge Magnum Wagon 2008',
    'Dodge Ram Pickup 3500 Crew Cab 2010',
    'Dodge Ram Pickup 3500 Quad Cab 2009',
    'Dodge Sprinter Cargo Van 2009',
    'Eagle Talon Hatchback 1998',
    'Ferrari 458 Italia Convertible 2012',
    'Ferrari 458 Italia Coupe 2012',
    'Ferrari California Convertible 2012',
    'Ferrari FF Coupe 2012',
    'FIAT 500 Abarth 2012',
    'FIAT 500 Convertible 2012',
    'Fisker Karma Sedan 2012',
    'Ford E-Series Wagon Van 2012',
    'Ford Edge SUV 2012',
    'Ford Expedition EL SUV 2009',
    'Ford F-150 Regular Cab 2007',
    'Ford F-150 Regular Cab 2012',
    'Ford F-450 Super Duty Crew Cab 2012',
    'Ford Fiesta Sedan 2012',
    'Ford Focus Sedan 2007',
    'Ford Freestar Minivan 2007',
    'Ford GT Coupe 2006',
    'Ford Mustang Convertible 2007',
    'Ford Ranger SuperCab 2011',
    'Geo Metro Convertible 1993',
    'GMC Acadia SUV 2012',
    'GMC Canyon Extended Cab 2012',
    'GMC Savana Van 2012',
    'GMC Terrain SUV 2012',
    'GMC Yukon Hybrid SUV 2012',
    'Honda Accord Coupe 2012',
    'Honda Accord Sedan 2012',
    'Honda Odyssey Minivan 2007',
    'Honda Odyssey Minivan 2012',
    'HUMMER H2 SUT Crew Cab 2009',
    'HUMMER H3T Crew Cab 2010',
    'Hyundai Accent Sedan 2012',
    'Hyundai Azera Sedan 2012',
    'Hyundai Elantra Sedan 2007',
    'Hyundai Elantra Touring Hatchback 2012',
    'Hyundai Genesis Sedan 2012',
    'Hyundai Santa Fe SUV 2012',
    'Hyundai Sonata Hybrid Sedan 2012',
    'Hyundai Sonata Sedan 2012',
    'Hyundai Tucson SUV 2012',
    'Hyundai Veloster Hatchback 2012',
    'Hyundai Veracruz SUV 2012',
    'Infiniti G Coupe IPL 2012',
    'Infiniti QX56 SUV 2011',
    'Isuzu Ascender SUV 2008',
    'Jaguar XK XKR 2012',
    'Jeep Compass SUV 2012',
    'Jeep Grand Cherokee SUV 2012',
    'Jeep Liberty SUV 2012',
    'Jeep Patriot SUV 2012',
    'Jeep Wrangler SUV 2012',
    'Lamborghini Aventador Coupe 2012',
    'Lamborghini Diablo Coupe 2001',
    'Lamborghini Gallardo LP 570-4 Superleggera 2012',
    'Lamborghini Reventon Coupe 2008',
    'Land Rover LR2 SUV 2012',
    'Land Rover Range Rover SUV 2012',
    'Lincoln Town Car Sedan 2011',
    'Maybach Landaulet Convertible 2012',
    'Mazda Tribute SUV 2011',
    'McLaren MP4-12C Coupe 2012',
    'Mercedes-Benz 300-Class Convertible 1993',
    'Mercedes-Benz C-Class Sedan 2012',
    'Mercedes-Benz E-Class Sedan 2012',
    'Mercedes-Benz S-Class Sedan 2012',
    'Mercedes-Benz SL-Class Coupe 2009',
    'Mercedes-Benz Sprinter Van 2012',
    'MINI Cooper Roadster Convertible 2012',
    'Mitsubishi Lancer Sedan 2012',
    'Nissan 240SX Coupe 1998',
    'Nissan Juke Hatchback 2012',
    'Nissan Leaf Hatchback 2012',
    'Nissan NV Passenger Van 2012',
    'Plymouth Neon Coupe 1999',
    'Porsche Panamera Sedan 2012',
    'Ram C V Cargo Van Minivan 2012',
    'Rolls-Royce Ghost Sedan 2012',
    'Rolls-Royce Phantom Drophead Coupe Convertible 2012',
    'Rolls-Royce Phantom Sedan 2012',
    'Scion xD Hatchback 2012',
    'smart fortwo Convertible 2012',
    'Spyker C8 Convertible 2009',
    'Spyker C8 Coupe 2009',
    'Suzuki Aerio Sedan 2007',
    'Suzuki Kizashi Sedan 2012',
    'Suzuki SX4 Hatchback 2012',
    'Suzuki SX4 Sedan 2012',
    'Tesla Model S Sedan 2012',
    'Toyota 4Runner SUV 2012',
    'Toyota Camry Sedan 2012',
    'Toyota Corolla Sedan 2012',
    'Toyota Sequoia SUV 2012',
    'Volkswagen Beetle Hatchback 2012',
    'Volkswagen Golf Hatchback 1991',
    'Volkswagen Golf Hatchback 2012',
    'Volvo 240 Sedan 1993',
    'Volvo C30 Hatchback 2012',
    'Volvo XC90 SUV 2007',

]

stanfordcars_templates = [
    'a photo of a {}.',
    'a photo of the {}.',
    'a photo of my {}.',
    'i love my {}!',
    'a photo of my dirty {}.',
    'a photo of my clean {}.',
    'a photo of my new {}.',
    'a photo of my old {}.',
]

ucf101_classes = [
    'Apply Eye Makeup',
    'Apply Lipstick',
    'Archery',
    'Baby Crawling',
    'Balance Beam',
    'Band Marching',
    'Baseball Pitch',
    'Basketball',
    'Basketball Dunk',
    'Bench Press',
    'Biking',
    'Billiards',
    'Blow Dry Hair',
    'Blowing Candles',
    'Body Weight Squats',
    'Bowling',
    'Boxing Punching Bag',
    'Boxing Speed Bag',
    'Breast Stroke',
    'Brushing Teeth',
    'Clean And Jerk',
    'Cliff Diving',
    'Cricket Bowling',
    'Cricket Shot',
    'Cutting In Kitchen',
    'Diving',
    'Drumming',
    'Fencing',
    'Field Hockey Penalty',
    'Floor Gymnastics',
    'Frisbee Catch',
    'Front Crawl',
    'Golf Swing',
    'Haircut',
    'Hammer Throw',
    'Hammering',
    'Hand Stand Pushups',
    'Handstand Walking',
    'Head Massage',
    'High Jump',
    'Horse Race',
    'Horse Riding',
    'Hula Hoop',
    'Ice Dancing',
    'Javelin Throw',
    'Juggling Balls',
    'Jump Rope',
    'Jumping Jack',
    'Kayaking',
    'Knitting',
    'Long Jump',
    'Lunges',
    'Military Parade',
    'Mixing',
    'Mopping Floor',
    'Nunchucks',
    'Parallel Bars',
    'Pizza Tossing',
    'Playing Cello',
    'Playing Daf',
    'Playing Dhol',
    'Playing Flute',
    'Playing Guitar',
    'Playing Piano',
    'Playing Sitar',
    'Playing Tabla',
    'Playing Violin',
    'Pole Vault',
    'Pommel Horse',
    'Pull Ups',
    'Punch',
    'Push Ups',
    'Rafting',
    'Rock Climbing Indoor',
    'Rope Climbing',
    'Rowing',
    'Salsa Spin',
    'Shaving Beard',
    'Shotput',
    'Skate Boarding',
    'Skiing',
    'Skijet',
    'Sky Diving',
    'Soccer Juggling',
    'Soccer Penalty',
    'Still Rings',
    'Sumo Wrestling',
    'Surfing',
    'Swing',
    'Table Tennis Shot',
    'Tai Chi',
    'Tennis Swing',
    'Throw Discus',
    'Trampoline Jumping',
    'Typing',
    'Uneven Bars',
    'Volleyball Spiking',
    'Walking With Dog',
    'Wall Pushups',
    'Writing On Board',
    'Yo Yo',
]

ucf101_templates = [
    'a photo of a person {}.',
    'a video of a person {}.',
    'a example of a person {}.',
    'a demonstration of a person {}.',
    'a photo of the person {}.',
    'a video of the person {}.',
    'a example of the person {}.',
    'a demonstration of the person {}.',
    'a photo of a person using {}.',
    'a video of a person using {}.',
    'a example of a person using {}.',
    'a demonstration of a person using {}.',
    'a photo of the person using {}.',
    'a video of the person using {}.',
    'a example of the person using {}.',
    'a demonstration of the person using {}.',
    'a photo of a person doing {}.',
    'a video of a person doing {}.',
    'a example of a person doing {}.',
    'a demonstration of a person doing {}.',
    'a photo of the person doing {}.',
    'a video of the person doing {}.',
    'a example of the person doing {}.',
    'a demonstration of the person doing {}.',
    'a photo of a person during {}.',
    'a video of a person during {}.',
    'a example of a person during {}.',
    'a demonstration of a person during {}.',
    'a photo of the person during {}.',
    'a video of the person during {}.',
    'a example of the person during {}.',
    'a demonstration of the person during {}.',
    'a photo of a person performing {}.',
    'a video of a person performing {}.',
    'a example of a person performing {}.',
    'a demonstration of a person performing {}.',
    'a photo of the person performing {}.',
    'a video of the person performing {}.',
    'a example of the person performing {}.',
    'a demonstration of the person performing {}.',
    'a photo of a person practicing {}.',
    'a video of a person practicing {}.',
    'a example of a person practicing {}.',
    'a demonstration of a person practicing {}.',
    'a photo of the person practicing {}.',
    'a video of the person practicing {}.',
    'a example of the person practicing {}.',
    'a demonstration of the person practicing {}.',
]

imagenet_classes = ["tench", "goldfish", "great white shark", "tiger shark", "hammerhead shark", "electric ray", "stingray", "rooster", "hen", "ostrich", "brambling", "goldfinch", "house finch", "junco", "indigo bunting", "American robin", "bulbul", "jay", "magpie", "chickadee", "American dipper", "kite (bird of prey)", "bald eagle", "vulture", "great grey owl", "fire salamander", "smooth newt", "newt", "spotted salamander", "axolotl", "American bullfrog", "tree frog", "tailed frog", "loggerhead sea turtle", "leatherback sea turtle", "mud turtle", "terrapin", "box turtle", "banded gecko", "green iguana", "Carolina anole", "desert grassland whiptail lizard", "agama", "frilled-necked lizard", "alligator lizard", "Gila monster", "European green lizard", "chameleon", "Komodo dragon", "Nile crocodile", "American alligator", "triceratops", "worm snake", "ring-necked snake", "eastern hog-nosed snake", "smooth green snake", "kingsnake", "garter snake", "water snake", "vine snake", "night snake", "boa constrictor", "African rock python", "Indian cobra", "green mamba", "sea snake", "Saharan horned viper", "eastern diamondback rattlesnake", "sidewinder rattlesnake", "trilobite", "harvestman", "scorpion", "yellow garden spider", "barn spider", "European garden spider", "southern black widow", "tarantula", "wolf spider", "tick", "centipede", "black grouse", "ptarmigan", "ruffed grouse", "prairie grouse", "peafowl", "quail", "partridge", "african grey parrot", "macaw", "sulphur-crested cockatoo", "lorikeet", "coucal", "bee eater", "hornbill", "hummingbird", "jacamar", "toucan", "duck", "red-breasted merganser", "goose", "black swan", "tusker", "echidna", "platypus", "wallaby", "koala", "wombat", "jellyfish", "sea anemone", "brain coral", "flatworm", "nematode", "conch", "snail", "slug", "sea slug", "chiton", "chambered nautilus", "Dungeness crab", "rock crab", "fiddler crab", "red king crab", "American lobster", "spiny lobster", "crayfish", "hermit crab", "isopod", "white stork", "black stork", "spoonbill", "flamingo", "little blue heron", "great egret", "bittern bird", "crane bird", "limpkin", "common gallinule", "American coot", "bustard", "ruddy turnstone", "dunlin", "common redshank", "dowitcher", "oystercatcher", "pelican", "king penguin", "albatross", "grey whale", "killer whale", "dugong", "sea lion", "Chihuahua", "Japanese Chin", "Maltese", "Pekingese", "Shih Tzu", "King Charles Spaniel", "Papillon", "toy terrier", "Rhodesian Ridgeback", "Afghan Hound", "Basset Hound", "Beagle", "Bloodhound", "Bluetick Coonhound", "Black and Tan Coonhound", "Treeing Walker Coonhound", "English foxhound", "Redbone Coonhound", "borzoi", "Irish Wolfhound", "Italian Greyhound", "Whippet", "Ibizan Hound", "Norwegian Elkhound", "Otterhound", "Saluki", "Scottish Deerhound", "Weimaraner", "Staffordshire Bull Terrier", "American Staffordshire Terrier", "Bedlington Terrier", "Border Terrier", "Kerry Blue Terrier", "Irish Terrier", "Norfolk Terrier", "Norwich Terrier", "Yorkshire Terrier", "Wire Fox Terrier", "Lakeland Terrier", "Sealyham Terrier", "Airedale Terrier", "Cairn Terrier", "Australian Terrier", "Dandie Dinmont Terrier", "Boston Terrier", "Miniature Schnauzer", "Giant Schnauzer", "Standard Schnauzer", "Scottish Terrier", "Tibetan Terrier", "Australian Silky Terrier", "Soft-coated Wheaten Terrier", "West Highland White Terrier", "Lhasa Apso", "Flat-Coated Retriever", "Curly-coated Retriever", "Golden Retriever", "Labrador Retriever", "Chesapeake Bay Retriever", "German Shorthaired Pointer", "Vizsla", "English Setter", "Irish Setter", "Gordon Setter", "Brittany dog", "Clumber Spaniel", "English Springer Spaniel", "Welsh Springer Spaniel", "Cocker Spaniel", "Sussex Spaniel", "Irish Water Spaniel", "Kuvasz", "Schipperke", "Groenendael dog", "Malinois", "Briard", "Australian Kelpie", "Komondor", "Old English Sheepdog", "Shetland Sheepdog", "collie", "Border Collie", "Bouvier des Flandres dog", "Rottweiler", "German Shepherd Dog", "Dobermann", "Miniature Pinscher", "Greater Swiss Mountain Dog", "Bernese Mountain Dog", "Appenzeller Sennenhund", "Entlebucher Sennenhund", "Boxer", "Bullmastiff", "Tibetan Mastiff", "French Bulldog", "Great Dane", "St. Bernard", "husky", "Alaskan Malamute", "Siberian Husky", "Dalmatian", "Affenpinscher", "Basenji", "pug", "Leonberger", "Newfoundland dog", "Great Pyrenees dog", "Samoyed", "Pomeranian", "Chow Chow", "Keeshond", "brussels griffon", "Pembroke Welsh Corgi", "Cardigan Welsh Corgi", "Toy Poodle", "Miniature Poodle", "Standard Poodle", "Mexican hairless dog (xoloitzcuintli)", "grey wolf", "Alaskan tundra wolf", "red wolf or maned wolf", "coyote", "dingo", "dhole", "African wild dog", "hyena", "red fox", "kit fox", "Arctic fox", "grey fox", "tabby cat", "tiger cat", "Persian cat", "Siamese cat", "Egyptian Mau", "cougar", "lynx", "leopard", "snow leopard", "jaguar", "lion", "tiger", "cheetah", "brown bear", "American black bear", "polar bear", "sloth bear", "mongoose", "meerkat", "tiger beetle", "ladybug", "ground beetle", "longhorn beetle", "leaf beetle", "dung beetle", "rhinoceros beetle", "weevil", "fly", "bee", "ant", "grasshopper", "cricket insect", "stick insect", "cockroach", "praying mantis", "cicada", "leafhopper", "lacewing", "dragonfly", "damselfly", "red admiral butterfly", "ringlet butterfly", "monarch butterfly", "small white butterfly", "sulphur butterfly", "gossamer-winged butterfly", "starfish", "sea urchin", "sea cucumber", "cottontail rabbit", "hare", "Angora rabbit", "hamster", "porcupine", "fox squirrel", "marmot", "beaver", "guinea pig", "common sorrel horse", "zebra", "pig", "wild boar", "warthog", "hippopotamus", "ox", "water buffalo", "bison", "ram (adult male sheep)", "bighorn sheep", "Alpine ibex", "hartebeest", "impala (antelope)", "gazelle", "arabian camel", "llama", "weasel", "mink", "European polecat", "black-footed ferret", "otter", "skunk", "badger", "armadillo", "three-toed sloth", "orangutan", "gorilla", "chimpanzee", "gibbon", "siamang", "guenon", "patas monkey", "baboon", "macaque", "langur", "black-and-white colobus", "proboscis monkey", "marmoset", "white-headed capuchin", "howler monkey", "titi monkey", "Geoffroy's spider monkey", "common squirrel monkey", "ring-tailed lemur", "indri", "Asian elephant", "African bush elephant", "red panda", "giant panda", "snoek fish", "eel", "silver salmon", "rock beauty fish", "clownfish", "sturgeon", "gar fish", "lionfish", "pufferfish", "abacus", "abaya", "academic gown", "accordion", "acoustic guitar", "aircraft carrier", "airliner", "airship", "altar", "ambulance", "amphibious vehicle", "analog clock", "apiary", "apron", "trash can", "assault rifle", "backpack", "bakery", "balance beam", "balloon", "ballpoint pen", "Band-Aid", "banjo", "baluster / handrail", "barbell", "barber chair", "barbershop", "barn", "barometer", "barrel", "wheelbarrow", "baseball", "basketball", "bassinet", "bassoon", "swimming cap", "bath towel", "bathtub", "station wagon", "lighthouse", "beaker", "military hat (bearskin or shako)", "beer bottle", "beer glass", "bell tower", "baby bib", "tandem bicycle", "bikini", "ring binder", "binoculars", "birdhouse", "boathouse", "bobsleigh", "bolo tie", "poke bonnet", "bookcase", "bookstore", "bottle cap", "hunting bow", "bow tie", "brass memorial plaque", "bra", "breakwater", "breastplate", "broom", "bucket", "buckle", "bulletproof vest", "high-speed train", "butcher shop", "taxicab", "cauldron", "candle", "cannon", "canoe", "can opener", "cardigan", "car mirror", "carousel", "tool kit", "cardboard box / carton", "car wheel", "automated teller machine", "cassette", "cassette player", "castle", "catamaran", "CD player", "cello", "mobile phone", "chain", "chain-link fence", "chain mail", "chainsaw", "storage chest", "chiffonier", "bell or wind chime", "china cabinet", "Christmas stocking", "church", "movie theater", "cleaver", "cliff dwelling", "cloak", "clogs", "cocktail shaker", "coffee mug", "coffeemaker", "spiral or coil", "combination lock", "computer keyboard", "candy store", "container ship", "convertible", "corkscrew", "cornet", "cowboy boot", "cowboy hat", "cradle", "construction crane", "crash helmet", "crate", "infant bed", "Crock Pot", "croquet ball", "crutch", "cuirass", "dam", "desk", "desktop computer", "rotary dial telephone", "diaper", "digital clock", "digital watch", "dining table", "dishcloth", "dishwasher", "disc brake", "dock", "dog sled", "dome", "doormat", "drilling rig", "drum", "drumstick", "dumbbell", "Dutch oven", "electric fan", "electric guitar", "electric locomotive", "entertainment center", "envelope", "espresso machine", "face powder", "feather boa", "filing cabinet", "fireboat", "fire truck", "fire screen", "flagpole", "flute", "folding chair", "football helmet", "forklift", "fountain", "fountain pen", "four-poster bed", "freight car", "French horn", "frying pan", "fur coat", "garbage truck", "gas mask or respirator", "gas pump", "goblet", "go-kart", "golf ball", "golf cart", "gondola", "gong", "gown", "grand piano", "greenhouse", "radiator grille", "grocery store", "guillotine", "hair clip", "hair spray", "half-track", "hammer", "hamper", "hair dryer", "hand-held computer", "handkerchief", "hard disk drive", "harmonica", "harp", "combine harvester", "hatchet", "holster", "home theater", "honeycomb", "hook", "hoop skirt", "gymnastic horizontal bar", "horse-drawn vehicle", "hourglass", "iPod", "clothes iron", "carved pumpkin", "jeans", "jeep", "T-shirt", "jigsaw puzzle", "rickshaw", "joystick", "kimono", "knee pad", "knot", "lab coat", "ladle", "lampshade", "laptop computer", "lawn mower", "lens cap", "letter opener", "library", "lifeboat", "lighter", "limousine", "ocean liner", "lipstick", "slip-on shoe", "lotion", "music speaker", "loupe magnifying glass", "sawmill", "magnetic compass", "messenger bag", "mailbox", "tights", "one-piece bathing suit", "manhole cover", "maraca", "marimba", "mask", "matchstick", "maypole", "maze", "measuring cup", "medicine cabinet", "megalith", "microphone", "microwave oven", "military uniform", "milk can", "minibus", "miniskirt", "minivan", "missile", "mitten", "mixing bowl", "mobile home", "ford model t", "modem", "monastery", "monitor", "moped", "mortar and pestle", "graduation cap", "mosque", "mosquito net", "vespa", "mountain bike", "tent", "computer mouse", "mousetrap", "moving van", "muzzle", "metal nail", "neck brace", "necklace", "baby pacifier", "notebook computer", "obelisk", "oboe", "ocarina", "odometer", "oil filter", "pipe organ", "oscilloscope", "overskirt", "bullock cart", "oxygen mask", "product packet / packaging", "paddle", "paddle wheel", "padlock", "paintbrush", "pajamas", "palace", "pan flute", "paper towel", "parachute", "parallel bars", "park bench", "parking meter", "railroad car", "patio", "payphone", "pedestal", "pencil case", "pencil sharpener", "perfume", "Petri dish", "photocopier", "plectrum", "Pickelhaube", "picket fence", "pickup truck", "pier", "piggy bank", "pill bottle", "pillow", "ping-pong ball", "pinwheel", "pirate ship", "drink pitcher", "block plane", "planetarium", "plastic bag", "plate rack", "farm plow", "plunger", "Polaroid camera", "pole", "police van", "poncho", "pool table", "soda bottle", "plant pot", "potter's wheel", "power drill", "prayer rug", "printer", "prison", "missile", "projector", "hockey puck", "punching bag", "purse", "quill", "quilt", "race car", "racket", "radiator", "radio", "radio telescope", "rain barrel", "recreational vehicle", "fishing casting reel", "reflex camera", "refrigerator", "remote control", "restaurant", "revolver", "rifle", "rocking chair", "rotisserie", "eraser", "rugby ball", "ruler measuring stick", "sneaker", "safe", "safety pin", "salt shaker", "sandal", "sarong", "saxophone", "scabbard", "weighing scale", "school bus", "schooner", "scoreboard", "CRT monitor", "screw", "screwdriver", "seat belt", "sewing machine", "shield", "shoe store", "shoji screen / room divider", "shopping basket", "shopping cart", "shovel", "shower cap", "shower curtain", "ski", "balaclava ski mask", "sleeping bag", "slide rule", "sliding door", "slot machine", "snorkel", "snowmobile", "snowplow", "soap dispenser", "soccer ball", "sock", "solar thermal collector", "sombrero", "soup bowl", "keyboard space bar", "space heater", "space shuttle", "spatula", "motorboat", "spider web", "spindle", "sports car", "spotlight", "stage", "steam locomotive", "through arch bridge", "steel drum", "stethoscope", "scarf", "stone wall", "stopwatch", "stove", "strainer", "tram", "stretcher", "couch", "stupa", "submarine", "suit", "sundial", "sunglasses", "sunglasses", "sunscreen", "suspension bridge", "mop", "sweatshirt", "swim trunks / shorts", "swing", "electrical switch", "syringe", "table lamp", "tank", "tape player", "teapot", "teddy bear", "television", "tennis ball", "thatched roof", "front curtain", "thimble", "threshing machine", "throne", "tile roof", "toaster", "tobacco shop", "toilet seat", "torch", "totem pole", "tow truck", "toy store", "tractor", "semi-trailer truck", "tray", "trench coat", "tricycle", "trimaran", "tripod", "triumphal arch", "trolleybus", "trombone", "hot tub", "turnstile", "typewriter keyboard", "umbrella", "unicycle", "upright piano", "vacuum cleaner", "vase", "vaulted or arched ceiling", "velvet fabric", "vending machine", "vestment", "viaduct", "violin", "volleyball", "waffle iron", "wall clock", "wallet", "wardrobe", "military aircraft", "sink", "washing machine", "water bottle", "water jug", "water tower", "whiskey jug", "whistle", "hair wig", "window screen", "window shade", "Windsor tie", "wine bottle", "airplane wing", "wok", "wooden spoon", "wool", "split-rail fence", "shipwreck", "sailboat", "yurt", "website", "comic book", "crossword", "traffic or street sign", "traffic light", "dust jacket", "menu", "plate", "guacamole", "consomme", "hot pot", "trifle", "ice cream", "popsicle", "baguette", "bagel", "pretzel", "cheeseburger", "hot dog", "mashed potatoes", "cabbage", "broccoli", "cauliflower", "zucchini", "spaghetti squash", "acorn squash", "butternut squash", "cucumber", "artichoke", "bell pepper", "cardoon", "mushroom", "Granny Smith apple", "strawberry", "orange", "lemon", "fig", "pineapple", "banana", "jackfruit", "cherimoya (custard apple)", "pomegranate", "hay", "carbonara", "chocolate syrup", "dough", "meatloaf", "pizza", "pot pie", "burrito", "red wine", "espresso", "tea cup", "eggnog", "mountain", "bubble", "cliff", "coral reef", "geyser", "lakeshore", "promontory", "sandbar", "beach", "valley", "volcano", "baseball player", "bridegroom", "scuba diver", "rapeseed", "daisy", "yellow lady's slipper", "corn", "acorn", "rose hip", "horse chestnut seed", "coral fungus", "agaric", "gyromitra", "stinkhorn mushroom", "earth star fungus", "hen of the woods mushroom", "bolete", "corn cob", "toilet paper"]

imagenet_templates = [
    'a bad photo of a {}.',
    'a photo of many {}.',
    'a sculpture of a {}.',
    'a photo of the hard to see {}.',
    'a low resolution photo of the {}.',
    'a rendering of a {}.',
    'graffiti of a {}.',
    'a bad photo of the {}.',
    'a cropped photo of the {}.',
    'a tattoo of a {}.',
    'the embroidered {}.',
    'a photo of a hard to see {}.',
    'a bright photo of a {}.',
    'a photo of a clean {}.',
    'a photo of a dirty {}.',
    'a dark photo of the {}.',
    'a drawing of a {}.',
    'a photo of my {}.',
    'the plastic {}.',
    'a photo of the cool {}.',
    'a close-up photo of a {}.',
    'a black and white photo of the {}.',
    'a painting of the {}.',
    'a painting of a {}.',
    'a pixelated photo of the {}.',
    'a sculpture of the {}.',
    'a bright photo of the {}.',
    'a cropped photo of a {}.',
    'a plastic {}.',
    'a photo of the dirty {}.',
    'a jpeg corrupted photo of a {}.',
    'a blurry photo of the {}.',
    'a photo of the {}.',
    'a good photo of the {}.',
    'a rendering of the {}.',
    'a {} in a video game.',
    'a photo of one {}.',
    'a doodle of a {}.',
    'a close-up photo of the {}.',
    'a photo of a {}.',
    'the origami {}.',
    'the {} in a video game.',
    'a sketch of a {}.',
    'a doodle of the {}.',
    'a origami {}.',
    'a low resolution photo of a {}.',
    'the toy {}.',
    'a rendition of the {}.',
    'a photo of the clean {}.',
    'a photo of a large {}.',
    'a rendition of a {}.',
    'a photo of a nice {}.',
    'a photo of a weird {}.',
    'a blurry photo of a {}.',
    'a cartoon {}.',
    'art of a {}.',
    'a sketch of the {}.',
    'a embroidered {}.',
    'a pixelated photo of a {}.',
    'itap of the {}.',
    'a jpeg corrupted photo of the {}.',
    'a good photo of a {}.',
    'a plushie {}.',
    'a photo of the nice {}.',
    'a photo of the small {}.',
    'a photo of the weird {}.',
    'the cartoon {}.',
    'art of the {}.',
    'a drawing of the {}.',
    'a photo of the large {}.',
    'a black and white photo of a {}.',
    'the plushie {}.',
    'a dark photo of a {}.',
    'itap of a {}.',
    'graffiti of the {}.',
    'a toy {}.',
    'itap of my {}.',
    'a photo of a cool {}.',
    'a photo of a small {}.',
    'a tattoo of the {}.',
]

class_map = {
    'birdsnap': birdsnap_classes,
    'gtsrb': gtsrb_classes,
    'cifar-10': cifar10_classes,
    'caltech-101': caltech101_classes,
    'cifar-100': cifar100_classes,
    'country211': country211_classes,
    'fgvc-aircraft-2013b-variants102': fgvcaircraft_classes,
    'oxford-flower-102': flowers102_classes,
    'food-101': food101_classes,
    'kitti-distance': kitti_classes,
    'mnist': mnist_classes,
    'patch-camelyon': patchcamelyon_classes,
    'resisc45_clip': resisc45_classes,
    'stl10': stl10_classes,
    'sun397': sun397_classes,
    'stanford-cars': stanfordcars_classes,
    'ucf101': ucf101_classes,
    'voc-2007-classification': pascalvoc2007_classes,
    'oxford-iiit-pets': oxfordpets_classes,
    'eurosat_clip': eurosat_classes,
    'hateful-memes': hatefulmemes_classes,
    'rendered-sst2': sst2_classes,
    'dtd': describabletextures_classes,
    'fer-2013': facialemotionrecognition2013_classes,
    'imagenet-1k': imagenet_classes,
}

template_map = {
    'birdsnap': birdsnap_templates,
    'gtsrb': gtsrb_templates,
    'cifar-10': cifar100_templates,
    'caltech-101': caltech101_templates,
    'cifar-100': cifar100_templates,
    'country211': country211_templates,
    'fgvc-aircraft-2013b-variants102': fgvcaircraft_templates,
    'oxford-flower-102': flowers102_templates,
    'food-101': food101_templates,
    'kitti-distance': kitti_templates,
    'mnist': mnist_templates,
    'patch-camelyon': patchcamelyon_templates,
    'resisc45_clip': resisc45_templates,
    'stl10': stl10_templates,
    'sun397': sun397_templates,
    'stanford-cars': stanfordcars_templates,
    'ucf101': ucf101_templates,
    'voc-2007-classification': pascalvoc2007_templates,
    'oxford-iiit-pets': oxfordpets_templates,
    'eurosat_clip': eurosat_templates,
    'hateful-memes': hatefulmemes_templates,
    'rendered-sst2': sst2_templates,
    'dtd': describabletextures_templates,
    'fer-2013': facialemotionrecognition2013_templates,
    'imagenet-1k': imagenet_templates,
}
